volatile u16 t_ambient;

u8 read_adc(u16 *result, u8 cnl, u8 start_sgn)
{
 static u32 adc_cps=0;
 static u8 adc_cnt=0;
 static bit trg=0;  
 static bit cnl_tmp=0;
 
 if(start_sgn&&!trg || cnl_tmp!=cnl)
 {  
  cnl_tmp=cnl; 
  trg=1;
  adc_cps=adc_cnt=0;
  ADMUX &= 0xf0;
  ADMUX |= cnl_tmp;
  ADCSRA.ADSC=1;
 }
 
 if(trg)
 if(!ADCSRA.ADSC)
 { 
  adc_cps+= ADCW;
  ADCSRA.ADSC=1;
  if(!++adc_cnt) 
  { 
   *result = adc_cps>>8; 
   adc_cps = 0;
   trg=0; 
   return 1; 
  } 
 } 
 return 0; 
}

u8 read_ambt(u16 *somevar, const u16 Ct_diode, const u16 Cv_diode)
{
 u16 tmp;

 if(read_adc(&tmp,0,1))
 {  
  tmp = (u32)ADCMAX*tmp>>10;
  
  if(tmp>Cv_diode)
  {
   if(((u32)tmp-Cv_diode)*10*100/21 > Ct_diode)
   {
    *somevar = 0;
    return 1;
   }   
   else tmp = Ct_diode-((u32)tmp-Cv_diode)*10*100/21; 
  }
  else if(tmp<Cv_diode)tmp=(Ct_diode+((u32)Cv_diode-tmp)*10*100/21);
  else tmp=Ct_diode;
   
  *somevar = tmp;
  return 1;   
 }  
 return 0;
}